﻿
 	Shadowbox.init();  
    var SelectedCells = new Array();
    var RasterWidth;
    var RasterHeight;
    var LoopNumber=0;
    var x0=-1;
    var x1=-1;
    var y0=-1;
    var y1=-1;
    var CodeLines = new Array();
    VarTableAutoInc=0;
    PixelPrefix="Pixel";
    
    function coordinates(cx,cy){
      this.x=cx;
      this.y=cy;
    }
    
    function Init(){
      LoopNumber=0;
    }
    
    function SetTable(w,h){
      var NewRow, NewCell;
      var MyTable=document.createElement('table');
      MyTable.id="RasterTable";
      MyTable.className="pixelTable";
      NewRow=document.createElement('tr');
      NewCell=document.createElement('td');
      NewCell.className="emptyCell";
      NewCell.innerHTML="";
      NewRow.appendChild(NewCell);
      for (var j=0;j<=w-1;j++) {
        NewCell=document.createElement('td');
        NewCell.className="colHeader";
        NewCell.innerHTML=j;
        NewRow.appendChild(NewCell);
      }
      MyTable.appendChild(NewRow);
      
      for (var i=0;i<=h-1;i++){
        NewRow=document.createElement('tr');
        for (var j=0;j<=w;j++){
          NewCell=document.createElement('td');
          if (j==0){
            NewCell.className="rowHeader";
            NewCell.innerHTML=h-i-1;
          }
          else{
            NewCell.className="pixelCell";
            NewCell.innerHTML="<img alt='PixelImage' id='"+eval(h-i-1)+"-"+eval(j-1)+"' src='images/"+PixelPrefix+".png' onclick='ClickCell(this,"+eval(j-1)+","+eval(h-i-1)+")' onmouseover='MouseOverCell(this)' onmouseout='MouseOutCell(this)'>";
          }
          NewRow.appendChild(NewCell);
        }
        MyTable.appendChild(NewRow);
      }
      
      document.getElementById("PixelTable").innerHTML="";
      document.getElementById("PixelTable").appendChild(MyTable);
      document.getElementById("CodeTable").rows[0].className="highLighted";
    }
    
    function MouseOverCell(obj){
      if (SelectedCells.length==1){
        if (SelectedCells[0]!=obj)
          obj.src="images/"+PixelPrefix+"Gray.png";
        
      }
    }
    
    function MouseOutCell(obj){
      if (SelectedCells.length==1){
        if (SelectedCells[0]!=obj)
          obj.src="images/"+PixelPrefix+".png";
        
      }
    }
    
    function ClearAllCells(){
      while (CodeLines.length>0) CodeLines.pop();
      for (var k=0; k<=document.getElementById("RasterTable").getElementsByTagName("img").length-1;
           k++){
        document.getElementById("RasterTable").getElementsByTagName("img")[k].src="images/"+PixelPrefix+".png";
      }
      SelectedCells=[];
      x0=-1;
      x1=-1;
      y0=-1;
      y1=-1;
      document.getElementById("VariablesTableFooter").innerHTML="Από το σημείο (Απροσδιόριστο) στο (Απροσδιόριστο)";
    }
    
    function ClickCell(obj,i,j){
      if ((SelectedCells[0]==obj) || (SelectedCells[1]==obj)) {
        ClearAllCells();
        return;
      }
      
      if (SelectedCells.length==1){
      
      //if (i-x0)>0 && (j-y0)>0 && (j-y0)/(i-x0)<=1 {
      if ((i-x0)>0 && (j-y0)>0 && (j-y0)/(i-x0)<=1) {
        obj.src="images/"+PixelPrefix+"Black.png";
        SelectedCells.push(obj);
        x1=i;
        
        y1=j;
        document.getElementById("VariablesTableFooter").innerHTML="Από το σημείο ("+x0+","+y0+") στο ("+x1+","+y1+")";
        }
        else alert('Παρακαλώ επιλέξτε δύο σημεία από το πρώτο οκταμόριο.');
      }
      
      if (SelectedCells.length==0){
        obj.src="images/"+PixelPrefix+"Black.png";
        SelectedCells.push(obj);
        x0=i;
        
        y0=j;
        
        x1=-1;
        
        y1=-1;
        document.getElementById("VariablesTableFooter").innerHTML="Από το σημείο ("+x0+","+y0+") στο (Απροσδιόριστο)";
      }
    }
    
    function SetRaster(){
      RasterWidth=document.getElementById("ColsId").value;
      RasterHeight=document.getElementById("RowsId").value;
      if ((RasterWidth>0) && (RasterHeight>0))
        SetTable(RasterWidth,RasterHeight);
      Init();
      ClearAllCells();
    }
    
    function SetVariables(k,dx,dy,b,s,e,x,y,roundy){
      //k,x,y always on
      if (dx==1){
        
        document.getElementById("thdx").style.visibility="visible";
        document.getElementById("thdx").style.width="40px";
      }
      else{
        document.getElementById("thdx").style.visibility="hidden";
        document.getElementById("thdx").style.width="0px";
      }
      
      if (dy==1){
        
        document.getElementById("thdy").style.visibility="visible";
        document.getElementById("thdy").style.width="40px";
      }
      else{
        document.getElementById("thdy").style.visibility="hidden";
        document.getElementById("thdy").style.width="0px";
      }
      
      if (b==1){
        
        document.getElementById("thb").style.visibility="visible";
        document.getElementById("thb").style.width="40px";
      }
      else{
        document.getElementById("thb").style.visibility="hidden";
        document.getElementById("thb").style.width="0px";
      }
      
      if (s==1){
        
        document.getElementById("ths").style.visibility="visible";
        document.getElementById("ths").style.width="40px";
      }
      else{
        document.getElementById("ths").style.visibility="hidden";
        document.getElementById("ths").style.width="0px";
      }
      
      if (e==1){
        
        document.getElementById("therror").style.visibility="visible";
        document.getElementById("therror").style.width="40px";
      }
      else{
        document.getElementById("therror").style.visibility="hidden";
        document.getElementById("therror").style.width="0px";
      }
      
      if (roundy==1){
        
        document.getElementById("throundy").style.visibility="visible";
        document.getElementById("throundy").style.width="40px";
      }
      else{
        document.getElementById("throundy").style.visibility="hidden";
        document.getElementById("throundy").style.width="0px";
      }
      
    }
    
    function UpdateCodeLines(){
      if (SelectedCells.length<2) {
        document.getElementById("VariablesTableFooter").innerHTML="Παρακαλώ επιλέξτε αρχικό και τελικό σημείο στο πρώτο οκταμόριο.";
        return;
      }
      while (CodeLines.length>0) CodeLines.pop();
      VarTableAutoInc=0;
      while (document.getElementById("VariablesTable").rows.length>0) document.getElementById("VariablesTable").deleteRow(0);
      document.getElementById("VariablesTable").innerHTML="";
      if (document.getElementById("AlgorithmName").value=='SimpleLine' && SelectedCells.length>=2) ComputeSimpleCodeLine(x0,y0,x1,y1);
      if (document.getElementById("AlgorithmName").value=='Incremental' && SelectedCells.length>=2) ComputeIncrementalCodeLine(x0,y0,x1,y1);
      if (document.getElementById("AlgorithmName").value=='NoRound' && SelectedCells.length>=2) ComputeNoRoundCodeLine(x0,y0,x1,y1);
      if (document.getElementById("AlgorithmName").value=='Bresenham' && SelectedCells.length>=2) ComputeBresenhamCodeLine(x0,y0,x1,y1);
      LoopNumber=-1;
      Next();
    }
    
    function ReverseCoordinates(cx,cy){
      var RowsLength=document.getElementById("RasterTable").rows.length;
      var Reversed=new coordinates(cx+1,RowsLength-1-cy);
      return Reversed;
    }
    
    function setPixel(ax, ay, color){
      var PixelCoord=ReverseCoordinates(ax,ay);
      var spRows=document.getElementById("RasterTable").rows[PixelCoord.y];
      var spCell=spRows.cells[PixelCoord.x];
      spCell.getElementsByTagName("img")[0].src="images/"+PixelPrefix+color+".png";
    }
    
    function ComputeSimpleCodeLine(xx1, yy1, xx2, yy2){
      CodeLines.push(1);
      AddVariablesTableLine("-", "-", "-", "-", "-", "-", "-", "-");
      var s=(yy2-yy1)/(xx2-xx1);
      CodeLines.push(4);
      AddVariablesTableLine("-", "-", "-", s, "-", "-", "-", "-");
      var b=(yy1*xx2-yy2*xx1)/(xx2-xx1);
      CodeLines.push(5);
      AddVariablesTableLine("-", "-", b, s, "-", "-", "-", "-");
      var y=yy1;
      for (var x=xx1; x<=xx2; x++){
        
        CodeLines.push(6);
        AddVariablesTableLine("-", "-", b, s, "-", x, y, "-");
        y=s*x+b;
        CodeLines.push(7);
        AddVariablesTableLine("-", "-", b, s, "-", x, y, "-");
        if (x==xx1) setPixel(x,Math.round(y), "Black");
        else if (x==xx2) setPixel(x,Math.round(y), "Black");
        else setPixel(x,Math.round(y), "Gray");
        CodeLines.push(8);
        AddVariablesTableLine("-", "-", b, s, "-", x, y, Math.round(y));
      }
    }
    
    function ComputeIncrementalCodeLine(xx1, yy1, xx2, yy2){
      CodeLines.push(1);
      AddVariablesTableLine("-", "-", "-", "-", "-", "-", "-", "-");
      var s=(yy2-yy1)/(xx2-xx1);
      CodeLines.push(4);
      AddVariablesTableLine("-", "-", "-", s, "-", "-", "-", "-");
      var y=yy1;
      CodeLines.push(5);
      AddVariablesTableLine("-", "-", "-", s, "-", "-", y, "-");
      for (var x=xx1; x<=xx2; x++){
        
        CodeLines.push(6);
        if (x==xx1) setPixel(x,Math.round(y), "Black");
        else if (x==xx2) setPixel(x,Math.round(y), "Black");
        else setPixel(x,Math.round(y), "Gray");
        CodeLines.push(7);
        AddVariablesTableLine("-", "-", "-", s, "-", x, y, Math.round(y));
        y=y+s;
        CodeLines.push(8);
        AddVariablesTableLine("-", "-", "-", s, "-", x, y, "-");
      }
    }
    
      function ComputeNoRoundCodeLine(xx1, yy1, xx2, yy2){
      CodeLines.push(1);
      AddVariablesTableLine("-", "-", "-", "-", "-", "-", "-", "-");
      var s=(yy2-yy1)/(xx2-xx1);
      CodeLines.push(3);
      AddVariablesTableLine("-", "-", "-", s, "-", "-", "-", "-"); 
      var y=yy1;
      CodeLines.push(4);
      AddVariablesTableLine("-", "-", "-", s, "-", "-", y, "-");
      var err=0;
      CodeLines.push(5);
      AddVariablesTableLine("-", "-", "-", s, err, "-", y, "-");
      for (var x=xx1; x<=xx2; x++){
        CodeLines.push(6);
        AddVariablesTableLine("-", "-", "-", s, err, x, y, "-");
        if (x==xx1) setPixel(x,Math.round(y), "Black");
        else if (x==xx2) setPixel(x,Math.round(y), "Black");
        else setPixel(x,Math.round(y), "Gray");
        CodeLines.push(7);
        AddVariablesTableLine("-", "-", "-", s, err, x, y, Math.round(y)); 
        err=err+s;
        CodeLines.push(8);
        AddVariablesTableLine("-", "-", "-", s, err, x, y, "-");
        CodeLines.push(9);//if
        AddVariablesTableLine("-", "-", "-", s, err, x, y, "-");
        if (err>=0.5){
          y++;
          CodeLines.push(10);
          AddVariablesTableLine("-", "-", "-", s, err, x, y, "-");
          err--;
          CodeLines.push(11);
          AddVariablesTableLine("-", "-", "-", s, err, x, y, "-");
        }
      }
    }
         
    function ComputeBresenhamCodeLine(xx1, yy1, xx2, yy2){
      CodeLines.push(1);
      AddVariablesTableLine("-", "-", "-", "-", "-", "-", "-", "-");
      var dx=Math.abs(xx2-xx1);
      CodeLines.push(2);
      AddVariablesTableLine(dx, "-", "-", "-", "-", "-", "-", "-");
      var dy=Math.abs(yy2-yy1);
      CodeLines.push(3);
      AddVariablesTableLine(dx, dy, "-", "-", "-", "-", "-", "-");
      var err=-dx/2;
      CodeLines.push(4);
      AddVariablesTableLine(dx, dy, "-", "-", err, "-", "-", "-");
      var y=yy0;
      CodeLines.push(5);
      AddVariablesTableLine(dx, dy, "-", "-", err, "-", y, "-");
      for (var x=xx1; x<=xx2; x++){
        CodeLines.push(6);
        AddVariablesTableLine(dx, dy, "-", "-", err, x, y, "-");
        if (x==xx1) setPixel(x,Math.round(y), "Black");
        else if (x==xx2) setPixel(x,Math.round(y), "Black");
        else setPixel(x,Math.round(y), "Gray");
        CodeLines.push(7);
        AddVariablesTableLine(dx, dy, "-", "-", err, x, y, Math.round(y)); 
        err=err+dy;
        CodeLines.push(8);//err
        AddVariablesTableLine(dx, dy, "-", "-", err, x, y, "-");
        CodeLines.push(9);//if
        AddVariablesTableLine(dx, dy, "-", "-", err, x, y, "-");
        if (err>=0){
          y++;
          CodeLines.push(10);
          AddVariablesTableLine(dx, dy, "-", "-", err, x, y, "-");
          err=err-dx;
          CodeLines.push(11);
          AddVariablesTableLine(dx, dy, "-", "-", err, x, y, "-");
        }
      }
    }
    
    function LoadSourceCode(){
      while (CodeLines.length>0) CodeLines.pop();
      var r;
      var c;
      Init();
      var innerCode=new Array();
      if (document.getElementById("AlgorithmName").value=='SimpleLine'){
        innerCode.push("&nbsp;&nbsp;1|&nbsp; <span class='purple'>void</span> SimpleLineDrawing(<span class='purple'>int</span> x0, <span class='purple'>int</span> y0, <span class='purple'>int</span> x1, <span class='purple'>int</span> y1)<span class='red'>{</span>");
        innerCode.push("&nbsp;&nbsp;2|&nbsp; <span class='purple'>float</span> s,b,y;");
        innerCode.push("&nbsp;&nbsp;3|&nbsp; <span class='purple'>int</span> x;");
        innerCode.push("&nbsp;&nbsp;4|&nbsp; s = (y1 - y0)/(x1 - x0);<br>");
        innerCode.push("&nbsp;&nbsp;5|&nbsp; b = (y0*x1 - y1*x0) / (x1 - x0);<br>");
        innerCode.push("&nbsp;&nbsp;6|&nbsp; <span class='blue'>for</span> (<span class='purple'>int</span> x = x0; x <= x1; x++)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;7|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; y = s * x + b;<br>");
        
        innerCode.push("&nbsp;&nbsp;8|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; SetPixel(x, round(y));<br>");
        innerCode.push("&nbsp;&nbsp;9|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<span class='red'>}</span> <br>");
        innerCode.push("10|&nbsp; <span class='red'>}</span>");
        //SetVariables(1,0,0,1,1,0,1,1,1);
      }
      
      if (document.getElementById("AlgorithmName").value=='Incremental'){
        innerCode.push("&nbsp;&nbsp;1|&nbsp; <span class='purple'>void</span> IncrementalLineDrawing(<span class='purple'>int</span> x0, <span class='purple'>int</span> y0, <span class='purple'>int</span> x1, <span class='purple'>int</span> y1)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;2|&nbsp; <span class='purple'>float</span> s,y;<br>");
        innerCode.push("&nbsp;&nbsp;3|&nbsp; <span class='purple'>int</span> x;<br>");
        innerCode.push("&nbsp;&nbsp;4|&nbsp; s = (y1 - y0) / (x1 - x0);<br>");
        innerCode.push("&nbsp;&nbsp;5|&nbsp; y = y0;<br>");
        innerCode.push("&nbsp;&nbsp;6|&nbsp; <span class='blue'>for</span> (<span class='purple'>int</span> x = x0; x <= x1; x++)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;7|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; SetPixel(x, round(y));<br>");
        innerCode.push("&nbsp;&nbsp;8|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; y = y + s;<br>");
        
        innerCode.push("&nbsp;&nbsp;9|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<span class='red'>}</span><br>");
        innerCode.push("10|&nbsp; <span class='red'>}</span>");
      }
      
      if (document.getElementById("AlgorithmName").value=='NoRound'){
        innerCode.push("&nbsp;&nbsp;1|&nbsp; <span class='purple'>void</span> NoROundLineDrawing(<span class='purple'>int</span> x0, <span class='purple'>int</span> y0, <span class='purple'>int</span> x1, <span class='purple'>int</span> y1)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;2|&nbsp; <span class='purple'>float</span> s,err; <span class='purple'>int</span> x,y;<br>");
        innerCode.push("&nbsp;&nbsp;3|&nbsp; s = (y1 - y0) / (x1 - x0);<br>");
        innerCode.push("&nbsp;&nbsp;4|&nbsp; y = y0;<br>");
        innerCode.push("&nbsp;&nbsp;5|&nbsp; error = 0;<br>");
        innerCode.push("&nbsp;&nbsp;6|&nbsp; <span class='blue'>for</span> (<span class='purple'>int</span> x = x0; x <= x1; x++)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;7|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; SetPixel(x, round(y));<br>");
        innerCode.push("&nbsp;&nbsp;8|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; err = err + s;<br>");
        innerCode.push("&nbsp;&nbsp;9|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; <span class='blue'>if </span>(err>=0.5) <span class='red'>{</span><br>");
        innerCode.push("&nbsp;&nbsp;10|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;y++;<br>");
        innerCode.push("&nbsp;&nbsp;11|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;err--;<br>");
        innerCode.push("&nbsp;&nbsp;12|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;<span class='red'>}</span><br>");
        innerCode.push("&nbsp;&nbsp;13|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<span class='red'>}</span><br>");
        innerCode.push("14|&nbsp; <span class='red'>}</span>");
      }

      
      if (document.getElementById("AlgorithmName").value=='Bresenham'){
        innerCode.push("&nbsp;&nbsp;1|&nbsp; <span class='purple'>void</span> BresenhamLineDrawing (<span class='purple'>int</span> x0, <span class='purple'>int</span> y0, <span class='purple'>int</span> x1, <span class='purple'>int</span> y1)<span class='red'>{</span> <br>");
        innerCode.push("&nbsp;&nbsp;2|&nbsp; <span class='purple'>int</span> dx = abs(x1 - x0);<br>");
        innerCode.push("&nbsp;&nbsp;3|&nbsp; <span class='purple'>int</span> dy = abs(y1 - y0);<br>");
        
        innerCode.push("&nbsp;&nbsp;4|&nbsp; <span class='purple'>int</span> err = -dx / 2; /* error value */<br>");
        innerCode.push("&nbsp;&nbsp;5|&nbsp; y = y1;<br>");
        innerCode.push("&nbsp;&nbsp;6|&nbsp; <span class='blue'>for</span> (<span class='purple'>int</span> x = x0; x<=x1; x++)<span class='red'>{</span><br>");
        innerCode.push("&nbsp;&nbsp;7|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; setPixel(x,y);<br>");
        innerCode.push("&nbsp;&nbsp;8|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; error = error + dy;<br>");
        innerCode.push("&nbsp;&nbsp;9|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; <span class='blue'>if</span> (error >= 0)<span class='red'>{</span><br>");
        innerCode.push("10|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; y++;<br>");
        innerCode.push("11|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; error = error - dx;<br>");
        innerCode.push("12|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class='red'>}</span><br>");
        innerCode.push("13|&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<span class='red'>}</span><br>");
        innerCode.push("14|&nbsp; <span class='red'>}</span>");
      }
      while (document.getElementById("CodeTable").rows.length>0) document.getElementById("CodeTable").deleteRow(0);
      for (var j=0;j<=innerCode.length-1;j++) {
        r=document.getElementById("CodeTable").insertRow(j);
        c=r.insertCell(0);
        c.innerHTML=innerCode[j];
      }
      document.getElementById("CodeTable").rows[0].className = "hightLighted";
      UpdateCodeLines();
    }
    
    function toFixed(value, precision) {
      var power = Math.pow(10, precision || 0);
      return String(Math.round(value * power) / power);
    }
    
    function AddVariablesTableLine(dx,dy,b,s,e,x,y,roundy){
      if (typeof b =="number") b=parseFloat(b).toFixed(2);
      if (typeof s =="number") s=parseFloat(s).toFixed(2);
      if (typeof e =="number") e=parseFloat(e).toFixed(2);
      if (typeof y =="number") y=parseFloat(y).toFixed(2);
      if (typeof roundy =="number") roundy=parseFloat(roundy).toFixed(2);
      VarTableAutoInc++;
      var inner="<tr>"+
          "<td style='width:40px; text-align:left'>"+VarTableAutoInc+"</td>"+
          "<td style='width:40px; text-align:left'>"+dx+"</td>"+
          "<td style='width:40px; text-align:left'>"+dy+"</td>"+
          "<td style='width:40px; text-align:left'>"+b+"</td>"+
          "<td style='width:40px; text-align:left'>"+s+"</td>"+
          "<td style='width:40px; text-align:left'>"+e+"</td>"+
          "<td style='width:40px; text-align:left'>"+x+"</td>"+
          "<td style='width:40px; text-align:left'>"+y+"</td>"+
          "<td style='width:40px; text-align:left'>"+roundy+"</td>"+
          "</tr>";
      document.getElementById("VariablesTable").innerHTML=document.getElementById("VariablesTable").innerHTML+inner;
    }
    
    function NextStep(){
      if (LoopNumber<CodeLines.length-1){
        LoopNumber++;
        for (var x=0;x<=document.getElementById("CodeTable").rows.length-1;
             x++) document.getElementById("CodeTable").rows[x].className = "singleLine";
        document.getElementById("CodeTable").rows[CodeLines[LoopNumber]-1].className="highLighted";
        for (var x=0;x<=document.getElementById("VariablesTable").rows.length-1;
             x++) document.getElementById("VariablesTable").rows[x].className = "singleLine";
        document.getElementById("VariablesTable").rows[LoopNumber].className="highLighted";
      }
      else {
        for (var x=0;x<=document.getElementById("CodeTable").rows.length-1;
             x++) document.getElementById("CodeTable").rows[x].className="singleLine";
        document.getElementById("CodeTable").rows[0].className = "highLighted";
        for (var x=0;x<=document.getElementById("VariablesTable").rows.length-1;
             x++) document.getElementById("VariablesTable").rows[x].className = "singleLine";
        document.getElementById("VariablesTable").rows[0].className="highLighted";
      }
      HighLightPixel();
    }
    
    function PreviousStep(){
      if (LoopNumber>0){
        LoopNumber--;
        for (var x=0;x<=document.getElementById("CodeTable").rows.length-1;
             x++) document.getElementById("CodeTable").rows[x].className = "singleLine";
        document.getElementById("CodeTable").rows[CodeLines[LoopNumber]-1].className="highLighted";
        for (var x=0;x<=document.getElementById("VariablesTable").rows.length-1;
             x++) document.getElementById("VariablesTable").rows[x].className = "singleLine";
        document.getElementById("VariablesTable").rows[LoopNumber].className="highLighted";
      }
      else {
        for (var x=0;x<=document.getElementById("CodeTable").rows.length-1;
             x++) document.getElementById("CodeTable").rows[x].className="singleLine";
        document.getElementById("CodeTable").rows[0].className = "highLighted";
        for (var x=0;x<=document.getElementById("VariablesTable").rows.length-1;
             x++) document.getElementById("VariablesTable").rows[x].className = "singleLine";
        document.getElementById("VariablesTable").rows[0].className="highLighted";
      }
      HighLightPixel();
    }
    
    function ChangePixelPrefix(){
      if (document.getElementById("PixelPrefixChanger").value=="Circles") PixelPrefix="Pixel";
      if (document.getElementById("PixelPrefixChanger").value=="Squares") PixelPrefix="Square";
      RefreshRaster();
    }
    
    function RefreshRaster(){
      var filename;
      for (var y=1;y<=document.getElementById("RasterTable").rows.length-1;
           y++){
        for (var x=1;x<=document.getElementById("RasterTable").rows[y].cells.length-1;
             x++){
          
          if (document.getElementById("RasterTable").rows[y].cells[x].getElementsByTagName("img").length>0){
            filename=document.getElementById("RasterTable").rows[y].cells[x].getElementsByTagName("img")[0].src.replace(/^.*[\\\/]/, '');
            if (filename=="Pixel.png" || filename=="Square.png")
              document.getElementById("RasterTable").rows[y].cells[x].getElementsByTagName("img")[0].src="images/"+PixelPrefix+".png";
            if (filename=="PixelBlack.png"  || filename=="SquareBlack.png") 
              document.getElementById("RasterTable").rows[y].cells[x].getElementsByTagName("img")[0].src="images/"+PixelPrefix+"Black.png";
            if (filename=="PixelGray.png" || filename=="SquareGray.png") 
              document.getElementById("RasterTable").rows[y].cells[x].getElementsByTagName("img")[0].src="images/"+PixelPrefix+"Gray.png";
          }
        }
      }
    }
    
    function HighLightPixel(){
      for (var y=1;y<=document.getElementById("RasterTable").rows.length-1;y++){
        for (var x=1;x<=document.getElementById("RasterTable").rows[y].cells.length-1;x++){
          document.getElementById("RasterTable").rows[y].cells[x].className="pixelCell";
        }
      }
      var xx=Math.round(document.getElementById("VariablesTable").rows[LoopNumber].cells[6].innerHTML);
      var yy=Math.round(document.getElementById("VariablesTable").rows[LoopNumber].cells[8].innerHTML);
        var PixelCoord=ReverseCoordinates(xx,yy);
        document.getElementById("RasterTable").rows[PixelCoord.y].cells[PixelCoord.x].className="pixelSelectedCell";
    }
                             


